#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g(200000);
vector<long long> d(200000, -1);
vector<int> p(200000);

void bfs(int s) {
    queue<int> q;
    q.push(s);
    d[s] = 0;

    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u : g[v]) {
            if (d[u] == -1) {
                p[u] = v;
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }
}

int main() {
    int n, k, t;
    cin >> n >> k >> t;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    bfs(1);
    sort(d.begin(), d.end());
    if (d[199999] == 1) {
        cout << 1;
    } else {
        cout << d[199998];
    }
    return 0;
}